module ActiveResource

  #
  # default decode() removes root when there's a single element,
  # we don't want that for custom methods.
  #
  module Formats
    module XmlFormat
      def plain_decode(xml)
        Hash.from_xml(xml)
      end
    end
    module JsonFormat
      def plain_decode(json)
        ActiveSupport::JSON.decode(json)
      end
    end
  end
end
