module ActiveResource::Hel
  HEADERS = {
    'User-Agent' => "ActiveResource::Hel #{ActiveResource::Hel::VERSION}",
    'X-REST-Client' => "ActiveResource::Hel #{ActiveResource::Hel::VERSION}",
    'Accept' => 'application/json'
  }

  class Connection < ActiveResource::Connection
    include ActiveResource::Hel::Extensions::Cache
    include ActiveResource::Hel::Extensions::Authentication
    
    attr_accessor :hel_identity, :hel_secret
    
    def initialize(*args)
      ActiveResource::Connection.send(:include, ActiveResource::Hel::Extensions::Debugging) if ENV['ARES_HEL_DEBUG']
      super
      @default_header = HEADERS
    end
  end
end
