module ActiveResource::Hel
  module DefaultScopes
    extend ActiveSupport::Concern

    included do

      scope :unscoped, Proc.new { where() }

      scope :conditions, Proc.new { |hash={}|
        state = self
        hash.each { | k, v | state = state.filter(k, '=', v) }
        state
      }

      scope :raw_filter, Proc.new { |f|
        set_filter f
      }

      scope :filter, Proc.new { |field, operator, value|
        raw_filter(:a => {:field => field} , :o => operator.to_s, :b => value)
      }

      scope :my, Proc.new { |n|
        my
      }

      scope :limit, Proc.new { |n|
        where(:limit => n)
      }

      scope :start, Proc.new { |n|
        where(:start => n)
      }

      scope :offset, Proc.new { |n|
        where(:start => n)
      }

      scope :view, Proc.new { |v|
        where(:view => v)
      }

      scope :api_scopes, Proc.new { |n|
        where(:scopes => n)
      }
    end
  end
end