
module ActiveResource::Hel
  class EmbeddedCollection < Collection

    attr_reader :destroyed

    def initialize(original_collection = [], options = {})
      super
      @destroyed = []
    end

    #def each_with_destroyed
    #  @elements.each
    #end

    #def each
    #  @elements.select { |z| !z.destroyed? }.each
    #end

    def push(obj)
      raise ArgumentError, "Object is not of class #{model}" unless obj.is_a?(model)

      mark_dirty
      @elements.push obj
    end
    alias_method :<<, :push

    def find(id)
      @elements.find { |z| z.id.to_s == id.to_s}
    end

    def destroy(id)
     element = find(id)
      if element && !element.destroyed?
        mark_destroyed(element.id)
        @elements.delete(element)
        #element.destroy
      end
    end

    def clear_embedded_changes
      @destroyed = []
      changed_items.each {|i| i.changed_attributes.clear }
    end

    def changed_items
      @elements.select { |e| e.changed? }
    end

    private

    def mark_destroyed(id)
      mark_dirty
      @destroyed << id
    end
  end
end
