module ActiveResource::Hel
  class EmbeddedResource < Resource


    def initialize(attributes = {}, persisted = false)
      super
      @_destroyed = false
      @_parent = nil
    end

    def destroy
      @_destroyed = true
      self
    end

    def destroyed?
      @_destroyed
    end

    def update_attribute(name, value)
      set_attribute(name, value)
    end
    alias_method :update_attribute, :assign_attribute

    def update_attributes(attributes)
      attributes.each do |name,value|
        update_attribute name, value
      end
    end
    alias_method :update_attributes, :assign_attributes

  end
end