module ActiveResource::Hel
  class Railtie < ::Rails::Railtie
    initializer "activeresource-hel_initialization" do
      config_file = ::Rails.root.join('config', 'activeresource_hel.yml')
      env_config = if ENV['ACTIVERESOURCE_HEL_SITE'].present? &&
         ENV['ACTIVERESOURCE_HEL_IDENTITY'].present? &&
         ENV['ACTIVERESOURCE_HEL_SECRET'].present?
        {
          site: ENV['ACTIVERESOURCE_HEL_SITE'],
          identity: ENV['ACTIVERESOURCE_HEL_IDENTITY'],
          secret: ENV['ACTIVERESOURCE_HEL_SECRET']
        }
      end
      if !config_file.exist? && env_config.blank?
        raise StandardError.new("Configuration for ActiveResource::Hel missing")
      end
      config = {}
      config = YAML.load(ERB.new(config_file.read).result).deep_symbolize_keys if config_file.exist?
      config = config.merge({ ::Rails.env => env_config }.deep_symbolize_keys) if env_config.present?
      ActiveResource::Hel::Resource.configurations = config
      ActiveResource::Hel::Resource.use_configuration ::Rails.env.to_sym
      ActiveResource::Hel::Resource.logger = ::Rails.logger
      ActiveResource::Hel::Resource.cache = ::Rails.cache
    end
  end
end
